from django.shortcuts import render
# from mainApp.models import *
from clvoucherApp.models import *
from clvoucherApp.serializers import *
from django.shortcuts import render,redirect
from django.contrib.auth.decorators import login_required,user_passes_test
from django.utils.decorators import method_decorator
from clmainApp.utils import *
from rest_framework import status
from rest_framework.response import Response
from rest_framework.views import APIView
from datetime import datetime,timedelta
from django.db.models import Q
from django.db.models.functions import Coalesce
from django.db.models import Count,Max,Sum
from clvoucherApp.models import *
# Create your views here.

##### Vouchers  الكوبونات########

class VouchersApi(APIView):
    @method_decorator(user_passes_test(lambda u: u.has_perm('ClManagement.view_Vouchers'), login_url='/main/login/'))
    def get(self,request):
        # branchId = getBranchId(request)
        # if not branchId : return redirect('clauthApp:home')
        branches = Branch.objects.all()
        all_vouchers =Voucher.objects.all().order_by("-is_active","-created_at")
        all_vouchers_srl=VoucherSerializer(all_vouchers,many=True)
        return render(request,"Clinic/clvoucherApp/vouchers.html",{"all_vouchers":all_vouchers_srl.data,"branches":branches,
        'activePage':'Vouchers'})

    #@method_decorator(user_passes_test(lambda u: u.has_perm('ClManagement.add_Voucher'), login_url='/main/login/'))    
    @method_decorator(user_passes_test(lambda u: any(u.has_perm(perm) for perm in ['BrManagement.add_BranchVoucher', 'ClManagement.add_Voucher']), login_url='/auth/login/'))
    def post(self,request):
        # branchId = getBranchId(request)
        # if not branchId : return redirect('clauthApp:home')
        data = request.data
        data._mutable = True
        created_by_id = request.user.id
        request.data.update({"created_by":created_by_id})
        serializedObj= VoucherSerializer(data=data)
        if serializedObj.is_valid():
            serializedObj.save()
            return Response(status=status.HTTP_201_CREATED)
        else :return Response(serializedObj.errors,status=status.HTTP_400_BAD_REQUEST)

class VoucherApi(APIView):
    def get_object(self,pk):
        try:
            return Voucher.objects.get(pk=pk)
        except Voucher.DoesNotExist:
            return None    

    @method_decorator(user_passes_test(lambda u: any(u.has_perm(perm) for perm in ['BrManagement.change_BranchVoucher', 'ClManagement.change_Voucher']), login_url='/auth/login/'))
    #@method_decorator(user_passes_test(lambda u: u.has_perm('ClManagement.change_Voucher'), login_url='/main/login/'))
    def put(self,request,pk):
        request.data._mutable = True
        request.data.update({"created_by":request.user.id})
        obj=self.get_object(pk)
        serializedObj= VoucherSerializer(obj,data=request.data,partial=True)
        if serializedObj.is_valid():
            serializedObj.save()
            return Response(status=status.HTTP_200_OK)
        else : return Response(serializedObj.errors,status=status.HTTP_400_BAD_REQUEST)

    @method_decorator(user_passes_test(lambda u: any(u.has_perm(perm) for perm in ['BrManagement.delete_BranchVoucher', 'ClManagement.delete_Voucher']), login_url='/auth/login/'))
    #@method_decorator(user_passes_test(lambda u: u.has_perm('ClManagement.delete_Voucher'), login_url='/main/login/'))
    def delete(self,request,pk):
        obj=self.get_object(pk)
        if obj :
            try:
                obj.delete()
                return Response(status=status.HTTP_204_NO_CONTENT)
            except Exception as err_msg: 
                    return Response(data ="{}".format(str(err_msg)),status=status.HTTP_405_METHOD_NOT_ALLOWED)
        else : return Response(status=status.HTTP_404_NOT_FOUND)

class BrVouchersApi(APIView):
    @method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.view_Vouchers'), login_url='/main/login/'))
    def get(self,request):
        branchId = getBranchId(request)
        if not branchId : return redirect('clauthApp:home')
        branches = Branch.objects.all()
        all_vouchers =Voucher.objects.filter(branch_id=branchId).order_by("-is_active","-created_at")
        all_vouchers_srl=VoucherSerializer(all_vouchers,many=True)
        return render(request,"Clinic/clvoucherApp/br_vouchers.html",{"all_vouchers":all_vouchers_srl.data,"branches":branches,
        'activePage':'Vouchers'})

from clmainApp.whatsapp_templates import send_voucher_notification
# get patient vouchers , add patient vouchers 
class PatientVouchersApi(APIView):
    @method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.view_add_PatientVoucher'), login_url='/main/login/'))
    def get(self,request,pt_id):
        #branchId = getBranchId(request)
        #if not branchId : return redirect('clauthApp:home')
        pt_vouchers =PatientVoucher.objects.filter(patient_id=pt_id).order_by("-created_at")
        pt_vouchers_srl=PatientVoucherSerializer(pt_vouchers,many=True)
        return Response(pt_vouchers_srl.data,status=status.HTTP_200_OK)

    @method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.view_add_PatientVoucher'), login_url='/main/login/'))
    def post(self,request,pt_id):
        # branchId = getBranchId(request)
        # if not branchId : return redirect('clauthApp:home')
        data = request.data
        data._mutable = True
        created_by_id = request.user.id        
        data.update({"created_by":created_by_id,"patient":pt_id})
        serializedObj= PatientVoucherSerializer(data=data)
        if serializedObj.is_valid():
            serializedObj.save()
            response_data = {"created_obj":serializedObj.data}
            try :#discount_value_sessions, max_sessions, discount_value_visits, max_visits,
                pt_obj = Patient.objects.get(id=pt_id)
                is_msg_sent = send_voucher_notification("",pt_obj.number_1,True,pt_obj.fullname,data["voucher_code_assigned"],data["expires_at"],
                            data["discount_amount_sessions_assigned"],data["max_sessions"],data["discount_amount_visits_assigned"],data["max_visits"])
                if is_msg_sent:
                    new_pt_voucher_id = serializedObj.data ["id"]
                    PatientVoucher.objects.filter(id=new_pt_voucher_id).update(is_wa_sent=True)
                    response_data["created_obj"]["wa_status_code"] = 200
                    response_data["wa_status"] = " تم إرسال رسالة الواتساب بنجاح"
                else : response_data["wa_status"] = " عذراً , لم نتمكن من ارسال رسالة الواتساب"
            except Exception as err_msg:
                #print(err_msg)
                response_data["created_obj"]["wa_status_code"] = 400
                response_data["wa_status"] = " عذراً , لم نتمكن من ارسال رسالة الواتساب -  3rd party error "
            return Response(response_data,status=status.HTTP_201_CREATED)
        else : return Response(serializedObj.errors,status=status.HTTP_400_BAD_REQUEST)

class PatientVouchersWaApi(APIView):
    #@method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.add_PatientVoucher'), login_url='/main/login/'))
    def post(self,request,pt_voucher_id):
        response_data = {}
        try : 
            ptv = PatientVoucher.objects.get(id=pt_voucher_id)
            #print(ptv.__dict__)
            pt_number_1 = ptv.patient.number_1
            pt_fullname = ptv.patient.fullname            
            ptv_campaign = ptv.campaign
            if ptv_campaign :
                ptv_campaign_success_count = ptv_campaign.success_count
                ptv_campaign_failed_count = ptv_campaign.failed_count
            else :
                ptv_campaign_success_count = 0
                ptv_campaign_failed_count = 0
            msg_prefix = ptv_campaign.msg_prefix if ptv_campaign else ""
            
            is_msg_sent = send_voucher_notification(msg_prefix,pt_number_1,True,pt_fullname,ptv.voucher_code_assigned,ptv.expires_at,
                ptv.discount_amount_sessions_assigned,ptv.max_sessions,ptv.discount_amount_visits_assigned,ptv.max_visits)
            if is_msg_sent  and ptv.msg_status != "pending":
                if ptv.msg_status == "failed" and not ptv.is_wa_sent :#else if it was success before ,, no need to change campaign numbers 
                    ptv_campaign.success_count = ptv_campaign_success_count + 1 
                    if ptv_campaign_failed_count > 0 : ptv_campaign.failed_count = ptv_campaign_failed_count - 1
                    ptv_campaign.save()
                ptv.is_wa_sent = True
                ptv.msg_status = 'sent'
                ptv.try_send_at = timezone.now()

            elif is_msg_sent and ptv.is_wa_sent :
                ptv.is_wa_sent = True
                ptv.msg_status = 'sent'
                ptv.try_send_at = timezone.now()
            #     ptv.is_wa_sent = False
            #     ptv.msg_status = 'failed'
            #     ptv.try_send_at = None
            # elif not is_msg_sent and ptv.is_msg_sent :
            #     ptv.is_wa_sent = False
            #     ptv.msg_status = 'failed'
                #ptv.try_send_at = None

            response_data["wa_status"] = " تم إرسال رسالة الواتساب بنجاح" if is_msg_sent else " عذراً , لم نتمكن من ارسال رسالة الواتساب"
            status_code = status.HTTP_201_CREATED
        except Exception as err_msg:
            #print(err_msg)
            response_data["wa_status"] = " عذراً , لم نتمكن من ارسال رسالة الواتساب -  3rd party error "
            status_code = status.HTTP_400_BAD_REQUEST
        return Response(response_data,status=status_code)

# get patient vouchers , add patient vouchers 
class PatientVouchersDataApi(APIView):
    #@method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.view_add_PatientVoucher'), login_url='/main/login/'))
    def get(self,request,pt_id):
        pt_vouchers =PatientVoucher.objects.filter(patient_id=pt_id,is_used_session=False,expires_at__gte=timezone.now().date()).values("id","voucher__name","voucher_code_assigned","max_sessions","discount_amount_sessions_assigned")
        pt_vouchers_list = [pt_vou for pt_vou in pt_vouchers]
        return Response(pt_vouchers_list,status=status.HTTP_200_OK)
            

class ValidateDiscountCodeSessionsApi(APIView):
    #@method_decorator(user_passes_test(lambda u: u.has_perm('ClManagement.add_Voucher'), login_url='/main/login/'))    
    #@method_decorator(user_passes_test(lambda u: any(u.has_perm(perm) for perm in ['BrManagement.add_BranchVoucher', 'ClManagement.add_Voucher']), login_url='/auth/login/'))
    def post(self,request):
        # branchId = getBranchId(request)
        # if not branchId : return redirect('clauthApp:home')
        data = request.data
        filtered_vouchers = PatientVoucher.objects.filter(voucher_code_assigned = data["voucher_code"],patient_id=data["patient_id"],expires_at__gte=timezone.now().date(),is_used_session=False).values("id","discount_amount_sessions_assigned","max_sessions")
        if filtered_vouchers : 
            voucher_obj = filtered_vouchers.first()
            response_data = {"valid_code":True,"discount_amount_sessions_assigned":voucher_obj["discount_amount_sessions_assigned"],"valid_code_id":voucher_obj["id"],"max_sessions":voucher_obj["max_sessions"]}
        else : response_data = {"valid_code":False,"discount_amount_sessions_assigned":0,"valid_code_id":0,"max_sessions":voucher_obj["max_sessions"]}
        return Response(response_data,status=status.HTTP_200_OK)


class ValidateDiscountCodeVisitsApi(APIView):
    #@method_decorator(user_passes_test(lambda u: u.has_perm('ClManagement.add_Voucher'), login_url='/main/login/'))    
    #@method_decorator(user_passes_test(lambda u: any(u.has_perm(perm) for perm in ['BrManagement.add_BranchVoucher', 'ClManagement.add_Voucher']), login_url='/auth/login/'))
    def post(self,request):
        # branchId = getBranchId(request)
        # if not branchId : return redirect('clauthApp:home')
        data = request.data
        # visits_uses_count__lt=models.F('max_visits')  # Check if uses count is less than max allowed
        #import pdb
        #pdb.set_trace()
        filtered_vouchers = PatientVoucher.objects.filter(voucher_code_assigned = data["voucher_code"],expires_at__gte=timezone.now().date(),
                                                          visits_uses_count__lt=models.F('max_visits')).values("id","discount_amount_visits_assigned","max_visits","visits_uses_count")
        if filtered_vouchers : 
            voucher_obj = filtered_vouchers.first()
            response_data = {"valid_code":True,"discount_amount_visits_assigned":voucher_obj["discount_amount_visits_assigned"],"valid_code_id":voucher_obj["id"],"max_visits":voucher_obj["max_visits"],"visits_uses_count":voucher_obj["visits_uses_count"],}
        else : response_data = {"valid_code":False,"discount_amount_visits_assigned":0,"valid_code_id":0,"max_visits":0,"visits_uses_count":0,}
        return Response(response_data,status=status.HTTP_200_OK)

from django.db.models import F,ExpressionWrapper, DurationField

class CampaignsApi(APIView):
    @method_decorator(user_passes_test(lambda u: u.has_perm('ClManagement.view_Campaigns'), login_url='/main/login/'))
    def get(self,request):
        # branchId = getBranchId(request)
        # if not branchId : return redirect('clauthApp:home')
        #branches = Branch.objects.all().values("id","name")
        vouchers = Voucher.objects.filter(is_active=True).values("id","name","branch__name")
        all_campaigns =Campaign.objects.all().order_by("-created_at")
        # Get all incomplete campaigns where counts match 
        incomplete_campaigns = all_campaigns.filter( total_recipients=F('success_count') + F('failed_count')).exclude(status='completed')
        incomplete_campaigns.update(status='completed')
        # Get the current time and calculate one hour from now
        now = timezone.now()
        half_hour = timedelta(minutes=30)
        #half_hour_from_now = now + timedelta(minutes=30)
        # Query for running campaigns with PatientVouchers to send within the next hour
        still_running_campaigns = all_campaigns.filter(status='running').annotate(max_try_send_at=Max('messages__try_send_at'))
        # Filter in Python for difference greater than 30 minutes
        should_paused_campaigns_ids = [ c.id for c in still_running_campaigns if (now - (c.max_try_send_at or c.updated_at)) > half_hour ]        
        still_running_campaigns.filter(id__in=should_paused_campaigns_ids).update(status='paused')
        #all_Campaigns_srl=CampaignSerializer(all_Campaigns,many=True)
        return render(request,"Clinic/clvoucherApp/campaigns.html",{"all_campaigns":all_campaigns,"branches":{},"vouchers":vouchers,
        'activePage':'Campaigns'})

    #@method_decorator(user_passes_test(lambda u: u.has_perm('ClManagement.add_Campaign'), login_url='/main/login/'))    
    @method_decorator(user_passes_test(lambda u: any(u.has_perm(perm) for perm in ['BrManagement.add_BranchCampaign', 'ClManagement.add_Campaign']), login_url='/auth/login/'))
    def post(self,request):
        # branchId = getBranchId(request)
        # if not branchId : return redirect('clauthApp:home')
        data = request.data
        data._mutable = True
        created_by_id = request.user.id
        data.update({"created_by":created_by_id})
        serializedObj= CampaignSerializer(data=data)
        if serializedObj.is_valid():
            serializedObj.save()
            return Response({"campaign_id":serializedObj.data["id"]},status=status.HTTP_201_CREATED)
        else :return Response(serializedObj.errors,status=status.HTTP_400_BAD_REQUEST)

from clmainApp.models import PatientStatus
from brsessionApp.models import SessionStatus 
from clvoucherApp.utils import generate_pt_voucher_code
from clvoucherApp.tasks import send_campaign_messages_async
from threading import Thread
class CampaignApi(APIView):
    def get_object(self,pk):
        try:
            return Campaign.objects.get(pk=pk)
        except Campaign.DoesNotExist:
            return None    
    def get(self,request,pk):
        campaign=self.get_object(pk)
        branches = Branch.objects.filter(id=campaign.voucher.branch_id).values('id','name')
        #all_doctors = User.objects.filter(user_category="2DR",is_active=True)
        #for branch in branches:branch["doctors"] = all_doctors.filter(groups__branch_id=branch["id"])
        all_pt_status=PatientStatus.objects.all().order_by('ps_order')
        session_status = SessionStatus.objects.all().order_by("code")
        return render(request,"Clinic/clvoucherApp/campaign.html",{"branches":branches,"campaign":campaign,
                      "all_pt_status":all_pt_status ,"session_status":session_status, 'activePage':'Campaigns'})
    #@method_decorator(user_passes_test(lambda u: any(u.has_perm(perm) for perm in ['BrManagement.change_BranchCampaign', 'ClManagement.change_Campaign']), login_url='/auth/login/'))
    #@method_decorator(user_passes_test(lambda u: u.has_perm('ClManagement.change_Campaign'), login_url='/main/login/'))
    def post(self,request,pk):
        data = request.data
        user_id = request.user.id
        data._mutable = True
        campaign_obj=self.get_object(pk)
        # import pdb
        # pdb.set_trace()
        serializedObj= CampaignSerializer(campaign_obj,data=data,partial=True)
        if serializedObj.is_valid():
            serializedObj.save()
            patients_ids = data.getlist('checked_patients[]') 
            pt_vouchers = []
            vou = campaign_obj.voucher
            voucher_code = vou.voucher_code
            discount_amount_sessions_assigned = vou.discount_value_sessions
            max_sessions = vou.max_sessions
            discount_amount_visits_assigned = vou.discount_value_visits
            max_visits = vou.max_visits
            validity_days = vou.validity_days
             # Calculate expiration date
            expires_at = (datetime.now() + timedelta(days=validity_days)).date()
            for pt_id in patients_ids:
                pt_voucher_code_assigned = generate_pt_voucher_code(voucher_code, pt_id, discount_amount_sessions_assigned, 
                    max_sessions, discount_amount_visits_assigned, max_visits, validity_days)
                pt_vou = PatientVoucher(
                    voucher= vou,
                    patient_id=pt_id,
                    voucher_code_assigned = pt_voucher_code_assigned,
                    discount_amount_sessions_assigned=discount_amount_sessions_assigned,
                    discount_amount_visits_assigned=discount_amount_visits_assigned,
                    max_sessions=max_sessions,
                    max_visits=max_visits,
                    expires_at = expires_at,
                    created_by_id = user_id,
                    campaign_id=campaign_obj.id
                )
                pt_vouchers.append(pt_vou)
            created_vouchers  = PatientVoucher.objects.bulk_create(pt_vouchers)
            Thread(target=send_campaign_messages_async, args=(campaign_obj.id,)).start() 
            #send_campaign_messages_async(campaign_obj.id)  # Returns immediately

            #send_campaign_messages_async.delay(campaign_obj.id)
            #send_campaign_messages_async(campaign_obj.id)
            #import pdb
            #pdb.set_trace()
            return Response(status=status.HTTP_201_CREATED)
        else : return Response(serializedObj.errors,status=status.HTTP_400_BAD_REQUEST)

    #@method_decorator(user_passes_test(lambda u: any(u.has_perm(perm) for perm in ['BrManagement.delete_BranchCampaign', 'ClManagement.delete_Voucher']), login_url='/auth/login/'))
    #@method_decorator(user_passes_test(lambda u: u.has_perm('ClManagement.delete_Campaign'), login_url='/main/login/'))
    # def delete(self,request,pk):
    #     obj=self.get_object(pk)
    #     if obj :
    #         try:
    #             obj.delete()
    #             return Response(status=status.HTTP_204_NO_CONTENT)
    #         except Exception as err_msg: 
    #                 return Response(data ="{}".format(str(err_msg)),status=status.HTTP_405_METHOD_NOT_ALLOWED)
    #     else : return Response(status=status.HTTP_404_NOT_FOUND)
from django.core.serializers.json import DjangoJSONEncoder
import json
class CampaignDataApi(APIView):
    def get_object(self,pk):
        try:
            return Campaign.objects.get(pk=pk)
        except Campaign.DoesNotExist:
            return None    
    def get(self,request,pk):
        campaign=self.get_object(pk)
        pt_vouchers =PatientVoucher.objects.filter(campaign_id=pk)
        #import pdb
        #pdb.set_trace()
        pt_vouchers_srl=PatientVoucherCustomSerializer(pt_vouchers,many=True)
        pt_vouchers_json = json.dumps(pt_vouchers_srl.data, cls=DjangoJSONEncoder)
        return render(request,"Clinic/clvoucherApp/campaign_data.html",{"campaign":campaign,
                      "pt_vouchers_json":pt_vouchers_json, 'activePage':'Campaigns'})

class CampaignStatusApi(APIView):
    def get_object(self,pk):
        try:
            return Campaign.objects.get(pk=pk)
        except Campaign.DoesNotExist:
            return None    
    def post(self,request,pk):
        data = request.data
        try :
            if data["new_action"] : #data["new_action"] == 'start' , will add later if new actions added 
                Thread(target=send_campaign_messages_async, args=(pk,)).start()
                is_action_success = True
                response_message =  "تم بدء الحملة التسويقية بنجاح  "
            else : 
                is_action_success = False
                response_message = "خطأ أثناء تنفيذ العملية المطلوبة  "
            return Response({"is_action_success":is_action_success,"response_message":response_message},status=status.HTTP_200_OK)

        except:
            return Response({"is_action_success":False,"response_message":"خطأ أثناء تنفيذ العملية المطلوبه"},status=status.HTTP_400_BAD_REQUEST)

#from brsessionApp.models import PatientSessionItem
from brsessionApp.serializers import PatientSessionSerializer
from brvisitApp.serializers import PatientVisitSerializer
from django.db.models import Subquery, OuterRef,Exists
from django.db.models.functions import Coalesce
from django.db.models import Exists, OuterRef, Subquery, Value
class UsedVouchersDataReportApi(APIView):
    @method_decorator(user_passes_test(lambda u: u.has_perm('ClManagement.view_UsedVouchersData'), login_url='/auth/login/'))
    def get(self,request):
        branches = Branch.objects.filter(is_active=True).values('id','name')
        return render(request,"Clinic/clvoucherApp/used_vouchers_report.html",
                      {"branches":branches,"page_source":"Clinic", 'activePage':'UsedVouchersData'})
    def post(self,request):
        data=request.data
        branch_id = data["branch_id"]
        startDateTime,endDateTime = getStartEndDateTime(data["startDate"],data["endDate"])
        
        # Then use Exists in your query
        sessions = PatientSession.objects.filter(
            voucher_discount__gt=0,
            created_at__range=[startDateTime, endDateTime],
            patient__branch_id=branch_id
        ).annotate(
            session_string=F('session__name'),
            created_by_name=F('created_by__name'),
            has_campaign=Exists(
                PatientVoucher.objects.filter(
                    pt_session_id=OuterRef('id'),  # OuterRef refers to the PatientSession's id
                    is_used_session=True,
                    campaign__isnull=False  # Ensures the voucher has a campaign
                )
            )
        ).values(
            'id', 'patient__fullname', 'patient__number_1',
            'session_string', 'created_at', 'is_package',
            'sessions_count', 'sessions_count_original',
            'sessions_cost', 'voucher_discount',
            'amount_required', 'created_by_name',
            'has_campaign'  # Boolean flag (True/False)
        ).order_by('created_at', 'patient_id')
        # Get visits with voucher discounts

        # Get visits with voucher discounts
        # This subquery just checks for campaign-related vouchers
        campaign_voucher_exists = PtVoucherVisits.objects.filter(
            pt_visit=OuterRef('pk'),
            pt_voucher__campaign__isnull=False,
            pt_voucher__discount_amount_visits_assigned__gt=0,
            pt_voucher__visits_uses_count__gt=0
        )

        # This subquery gets the latest voucher regardless of campaign
        latest_voucher_subquery = PtVoucherVisits.objects.filter(
            pt_visit=OuterRef('pk')
        ).order_by('-id')  # adjust ordering if needed

        # Main query
        visits = PatientVisit.objects.filter(
            voucher_discount__gt=0,
            created_at__range=[startDateTime, endDateTime],
            patient__branch_id=branch_id
        ).annotate(
            has_campaign=Exists(campaign_voucher_exists),
            voucher_patient_name=Coalesce(
                Subquery(latest_voucher_subquery.values('pt_voucher__patient__fullname')[:1]),
                Value('')
            ),
            voucher_patient_phone=Coalesce(
                Subquery(latest_voucher_subquery.values('pt_voucher__patient__number_1')[:1]),
                Value('')
            )
        ).values(
            'id',
            'patient__fullname',
            'patient__number_1',
            'voucher_patient_name',
            'voucher_patient_phone',
            'medicalservice__name',
            'created_at',
            'ms_cost',
            'voucher_discount',
            'amount_required',
            'created_by__name',
            'has_campaign'
        ).order_by('created_at')


        response_data = {
            'sessions': list(sessions),
            'visits': list(visits),
            #'session_vouchers': list(session_vouchers),
            #'visit_vouchers': list(visit_vouchers),
        }

        return Response(response_data, status=status.HTTP_200_OK)